/*	================= BST_Create ================
	Allocates dynamic memory for an BST tree head
	node and returns its address to caller
	   Pre    compare is address of compare function 
	          used when two nodes need to be compared 
	   Post   head allocated or error returned 
	   Return head node pointer; null if overflow 
*/
BST_TREE* BST_Create 
        (int  (*compare) (void* argu1, void* argu2))
{
//	Local Definitions 
	BST_TREE* tree;

//	Statements 
	tree = (BST_TREE*) malloc (sizeof (BST_TREE));
	if (tree)
	   {
	    tree->root    = NULL;
	    tree->count   = 0;
	    tree->compare = compare;
	   } // if 

	return tree;
}	// BST_Create 
