/*	==================== _insert ====================
	This function uses recursion to insert the new data 
	into a leaf node in the BST tree.
	   Pre    Application has called BST_Insert, which  
	          passes root and data pointer
	   Post   Data have been inserted
	   Return pointer to [potentially] new root
*/
NODE* _insert (BST_TREE* tree, NODE* root, NODE* newPtr)
{
//	Statements 
	if (!root)
	   // if NULL tree 
	   return newPtr;
 
	// Locate null subtree for insertion 
	if (tree->compare(newPtr->dataPtr, 
	                  root->dataPtr) < 0)
	   {
	    root->left = _insert(tree, root->left, newPtr);
	    return root; 
	   } // new < node 
	else 
	   // new data >= root data 
	   {
	    root->right = _insert(tree, root->right, newPtr);
	    return root;
	     } // else new data >= root data 
	return root;
}	// _insert 
