/*	===================== _retrieve ===================== 
	Searches tree for node containing requested key 
	and returns its data to the calling function.
	   Pre     _retrieve passes tree, dataPtr, root 
	           dataPtr is pointer to data structure 
	              containing key to be located 
	   Post    tree searched; data pointer returned 
	   Return  Address of data in matching node 
	           If not found, NULL returned 
*/
void* _retrieve (BST_TREE* tree, 
	              void* dataPtr, NODE* root)
{
//	Statements 
	if (root)
	    {
	     if (tree->compare(dataPtr, root->dataPtr) < 0)
	         return _retrieve(tree, dataPtr, root->left);
	     else if (tree->compare(dataPtr, root->dataPtr) > 0)
	         return _retrieve(tree, dataPtr, root->right);
	     else
	         // Found equal key 
	         return root->dataPtr;
	    }  // if root 
	else
	    // Data not in tree 
	    return NULL;
}	// _retrieve 
