/*	=============== BST_Destroy ============== 
	Deletes all data in tree and recycles memory.
	The nodes are deleted by calling a recursive
	function to traverse the tree in inorder sequence.
	   Pre      tree is a pointer to a valid tree 
	   Post     All data and head structure deleted 
	   Return   null head pointer
*/
BST_TREE* BST_Destroy (BST_TREE* tree) 
{
//	Statements 
	if (tree)
		_destroy (tree->root);
		
	// All nodes deleted. Free structure 
	free (tree);
	return NULL;
}	// BST_Destroy 
